summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 60b6e22)
raw | patch | inline | side by side (parent: 60b6e22)
author | Jonathan Nieder <jrnieder@gmail.com> | |
Sat, 20 Feb 2010 08:50:25 +0000 (02:50 -0600) | ||
committer | Junio C Hamano <gitster@pobox.com> | |
Sun, 21 Feb 2010 19:08:17 +0000 (11:08 -0800) |
Testing pagination requires (fake or real) access to a terminal so we
can see whether the pagination automatically kicks in, which makes it
hard to get good coverage when running tests without --verbose. There
are a number of ways to work around that:
- Replace all isatty calls with calls to a custom xisatty wrapper
that usually checks for a terminal but can be overridden for tests.
This would be workable, but it would require implementing xisatty
separately in three languages (C, shell, and perl) and making sure
that any code that is to be tested always uses the wrapper.
- Redirect stdout to /dev/tty. This would be problematic because
there might be no terminal available, and even if a terminal is
available, it might not be appropriate to spew output to it.
- Create a new pseudo-terminal on the fly and capture its output.
This patch implements the third approach.
The new test-terminal.perl helper uses IO::Pty from Expect.pm to create
a terminal and executes the program specified by its arguments with
that terminal as stdout. If the IO::Pty module is missing or not
working on a system, the test script will maintain its old behavior
(skipping most of its tests unless GIT_TEST_OPTS includes --verbose).
Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
can see whether the pagination automatically kicks in, which makes it
hard to get good coverage when running tests without --verbose. There
are a number of ways to work around that:
- Replace all isatty calls with calls to a custom xisatty wrapper
that usually checks for a terminal but can be overridden for tests.
This would be workable, but it would require implementing xisatty
separately in three languages (C, shell, and perl) and making sure
that any code that is to be tested always uses the wrapper.
- Redirect stdout to /dev/tty. This would be problematic because
there might be no terminal available, and even if a terminal is
available, it might not be appropriate to spew output to it.
- Create a new pseudo-terminal on the fly and capture its output.
This patch implements the third approach.
The new test-terminal.perl helper uses IO::Pty from Expect.pm to create
a terminal and executes the program specified by its arguments with
that terminal as stdout. If the IO::Pty module is missing or not
working on a system, the test script will maintain its old behavior
(skipping most of its tests unless GIT_TEST_OPTS includes --verbose).
Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
t/t7006-pager.sh | patch | blob | history | |
t/t7006/test-terminal.perl | [new file with mode: 0755] | patch | blob |
diff --git a/t/t7006-pager.sh b/t/t7006-pager.sh
index 4f52ea5732de3d25a87eb556b8ecb7786c469f8c..da0f96262dfa8a238da5c91c2ca0e5ce91d92e6a 100755 (executable)
--- a/t/t7006-pager.sh
+++ b/t/t7006-pager.sh
. ./test-lib.sh
rm -f stdout_is_tty
-test_expect_success 'is stdout a terminal?' '
+test_expect_success 'set up terminal for tests' '
if test -t 1
then
: > stdout_is_tty
+ elif
+ test_have_prereq PERL &&
+ "$PERL_PATH" "$TEST_DIRECTORY"/t7006/test-terminal.perl \
+ sh -c "test -t 1"
+ then
+ : > test_terminal_works
fi
'
if test -e stdout_is_tty
then
+ test_terminal() { "$@"; }
+ test_set_prereq TTY
+elif test -e test_terminal_works
+then
+ test_terminal() {
+ "$PERL_PATH" "$TEST_DIRECTORY"/t7006/test-terminal.perl "$@"
+ }
test_set_prereq TTY
else
- say stdout is not a terminal, so skipping some tests.
+ say no usable terminal, so skipping some tests
fi
unset GIT_PAGER GIT_PAGER_IN_USE
rm -f paginated.out
test_expect_success TTY 'some commands use a pager' '
- git log &&
+ test_terminal git log &&
test -e paginated.out
'
rm -f paginated.out
test_expect_success TTY 'some commands do not use a pager' '
- git rev-list HEAD &&
+ test_terminal git rev-list HEAD &&
! test -e paginated.out
'
rm -f paginated.out
test_expect_success TTY 'git --paginate rev-list uses a pager' '
- git --paginate rev-list HEAD &&
+ test_terminal git --paginate rev-list HEAD &&
test -e paginated.out
'
rm -f paginated.out
test_expect_success TTY 'no pager with --no-pager' '
- git --no-pager log &&
+ test_terminal git --no-pager log &&
! test -e paginated.out
'
rm -f paginated.out
git config color.ui auto
test_expect_success TTY 'color when writing to a pager' '
- TERM=vt100 git log &&
+ TERM=vt100 test_terminal git log &&
colorful paginated.out
'
: > default_pager_used
EOF
chmod +x $less &&
- PATH=.:$PATH git log &&
+ PATH=.:$PATH test_terminal git log &&
test -e default_pager_used
'
test_expect_success TTY 'PAGER overrides default pager' '
PAGER=": > PAGER_used" &&
export PAGER &&
- git log &&
+ test_terminal git log &&
test -e PAGER_used
'
PAGER=: &&
export PAGER &&
git config core.pager ": > core.pager_used" &&
- git log &&
+ test_terminal git log &&
test -e core.pager_used
'
git config core.pager : &&
GIT_PAGER=": > GIT_PAGER_used" &&
export GIT_PAGER &&
- git log &&
+ test_terminal git log &&
test -e GIT_PAGER_used
'
diff --git a/t/t7006/test-terminal.perl b/t/t7006/test-terminal.perl
--- /dev/null
@@ -0,0 +1,58 @@
+#!/usr/bin/perl
+use strict;
+use warnings;
+use IO::Pty;
+use File::Copy;
+
+# Run @$argv in the background with stdout redirected to $out.
+sub start_child {
+ my ($argv, $out) = @_;
+ my $pid = fork;
+ if (not defined $pid) {
+ die "fork failed: $!"
+ } elsif ($pid == 0) {
+ open STDOUT, ">&", $out;
+ close $out;
+ exec(@$argv) or die "cannot exec '$argv->[0]': $!"
+ }
+ return $pid;
+}
+
+# Wait for $pid to finish.
+sub finish_child {
+ # Simplified from wait_or_whine() in run-command.c.
+ my ($pid) = @_;
+
+ my $waiting = waitpid($pid, 0);
+ if ($waiting < 0) {
+ die "waitpid failed: $!";
+ } elsif ($? & 127) {
+ my $code = $? & 127;
+ warn "died of signal $code";
+ return $code - 128;
+ } else {
+ return $? >> 8;
+ }
+}
+
+sub xsendfile {
+ my ($out, $in) = @_;
+
+ # Note: the real sendfile() cannot read from a terminal.
+
+ # It is unspecified by POSIX whether reads
+ # from a disconnected terminal will return
+ # EIO (as in AIX 4.x, IRIX, and Linux) or
+ # end-of-file. Either is fine.
+ copy($in, $out, 4096) or $!{EIO} or die "cannot copy from child: $!";
+}
+
+if ($#ARGV < 1) {
+ die "usage: test-terminal program args";
+}
+my $master = new IO::Pty;
+my $slave = $master->slave;
+my $pid = start_child(\@ARGV, $slave);
+close $slave;
+xsendfile(\*STDOUT, $master);
+exit(finish_child($pid));